/* SVN FILE: $Id$ */
/**
* Project Name : Project Description
*
* @package className
* @subpackage subclassName
* @author $Author$
* @copyright $Copyright$
* @version $Revision$
* @lastrevision $Date$
* @modifiedby $LastChangedBy$
* @lastmodified $LastChangedDate$
* @license $License$
* @filesource $URL$
*/

/****************************************************************************
** ManDVD
**
** Created: Mon Apr 12 23:00:00 2010
**      by: Mikael Böhm
**
** Class to support preview in QFileDialog when creating DVD Video
** 
****************************************************************************/
//
// C++ Interface: 
// Author: Mikael Böhm <micko@bag.org>, (C) 2010
//
// Copyright: See COPYING file that comes with this distribution

#include <dialog.h>

void Preview::previewUrl(const QUrl & u)
{
    if (!u.path().isNull()) {
	if (u.path() != imagePath) {
	    imagePath = u.path();
	    if (!imagePath.endsWith("/", FALSE)) {
		QPixmap pixmap(imagePath);
		if (!pixmap.isNull()) {
		    QImage img = pixmap.convertToImage();
		    QPixmap pixmap(resizeImage(img));
		    setPixmap(pixmap);
		} else
		    setText(tr("This is not a pixmap"));
	    }
	}
    }
}

QImage Preview::resizeImage(QImage img)
{
    img = img.scale(WIDTH, HIGHT);
    return img;
}
