//
// C++ Interface: lang
//
// Description: Backend code for laguage support
//
// Author     : Mikael Bhm <micko@bag.org>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
// Language specific: Help with corrections of broken text in french by Brnice Garnier (b_garnier@hotmail.com)


/**
  * TRANSLATION INFORMATION!
  * If you are going to translate this file, please try to keep short words "short".
  * Space in main program are critical sometimes. Make sure you use filetype ISO-8859-15.
  * I have to stick with that right now since the files was encoded so from start and I
  * dont know right now how to get around that without a lot of trouble.
  */

#ifndef LANG_H
#define LANG_H

#include <qlabel.h>
#include <qiconview.h>
#include <qbuttongroup.h>
#include <qcombobox.h>
#include <qslider.h>
#include <qlistview.h>
#include <qtoolbutton.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qtextedit.h>
#include <qdir.h>
#include <qrect.h>

#endif

// Standard language items for comobox for subtitle belonging
static const char* langitems[] = { "AA (AFAR)", "AB (ABKHAZIAN)", "AF (AFRIKAANS)", "AR (ARABIC)", "BE (BYELORUSSIAN)", "BG (BULGARIAN)", "BO (TIBETAN)", "CS (CZECH)", "DA (DANISH)", "DE (GERMAN)", "EL (GREEK)", "EN (ENGLISH)", "ES (SPANISH)", "ET (ESTONIAN)", "FI (FINNISH)", "FR (FRENCH)", "GA (IRISH)", "HI (HINDI)", "HR (CROATIAN)", "HU (HUNGARIAN)", "IN (INDONESIAN)", "IS (ICELANDIC)", "IT (ITALIAN)", "IW (HEBREW)", "JA (JAPANESE)", "KA (GEORGIAN)", "KK (KAZAKH)", "KO (KOREAN)", "KU (KURDISH)", "LT (LITHUANIAN)", "LV (LATVIAN;LETTISH)", "MO (MOLDAVIAN)", "MY (BURMESE)", "NL (DUTCH)", "NO (NORWEGIAN)", "PL (POLISH)", "PT (PORTUGUESE)", "RO (ROMANIAN)", "RU (RUSSIAN)", "SH (SERBO-CROATIAN)", "SK (SLOVAK)", "SL (SLOVENIAN)", "SQ (ALBANIAN)", "SR (SERBIAN)", "SV (SWEDISH)", "TH (THAI)", "TR (TURKISH)", "ZH (CHINESE)", 0 };

/* ISO 639-2 Code
AA (AFAR)
AB (ABKHAZIAN)
AF (AFRIKAANS)
AM (AMHARIC)
AR (ARABIC)
AS (ASSAMESE)
AY (AYMARA)
AZ (AZERBAIJANI)
BA (BASHKIR)
BE (BYELORUSSIAN)
BG (BULGARIAN)
BH (BIHARI)
BI (BISLAMA)
BN (BENGALI;BANGLA)
BO (TIBETAN)
BR (BRETON)
CA (CATALAN)
CO (CORSICAN)
CS (CZECH)
CY (WELSH)
DA (DANISH)
DE (GERMAN)
DZ (BHUTANI)
EL (GREEK)
EN (ENGLISH)
EO (ESPERANTO)
ES (SPANISH)
ET (ESTONIAN)
EU (BASQUE)
FA (PERSIAN (farsi))
FI (FINNISH)
FJ (FIJI)
FO (FAROESE)
FR (FRENCH)
FY (FRISIAN)
GA (IRISH)
GD (SCOTS GAELIC)
GL (GALICIAN)
GN (GUARANI)
GU (GUJARATI)
HA (HAUSA)
HI (HINDI)
HR (CROATIAN)
HU (HUNGARIAN)
HY (ARMENIAN)
IA (INTERLINGUA)
IE (INTERLINGUE)
IK (INUPIAK)
IN (INDONESIAN)
IS (ICELANDIC)
IT (ITALIAN)
IW (HEBREW)
JA (JAPANESE)
JI (YIDDISH)
JV (JAVANESE)
KA (GEORGIAN)
KK (KAZAKH)
KL (GREENLANDIC)
KM (CAMBODIAN)
KN (KANNADA)
KO (KOREAN)
KS (KASHMIRI)
KU (KURDISH)
KY (KIRGHIZ)
LA (LATIN)
LN (LINGALA)
LO (LAOTHIAN)
LT (LITHUANIAN)
LV (LATVIAN;LETTISH)
MG (MALAGASY)
MI (MAORI)
MK (MACEDONIAN)
ML (MALAYALAM)
MN (MONGOLIAN)
MO (MOLDAVIAN)
MR (MARATHI)
MS (MALAY)
MT (MALTESE)
MY (BURMESE)
NA (NAURU)
NE (NEPALI)
NL (DUTCH)
NO (NORWEGIAN)
OC (OCCITAN)
OM (AFAN (OROMO))
OR (ORIYA)
PA (PUNJABI)
PL (POLISH)
PS (PASHTO;PUSHTO)
PT (PORTUGUESE)
QU (QUECHUA)
RM (RHAETO-ROMANCE)
RN (KURUNDI)
RO (ROMANIAN)
RU (RUSSIAN)
RW (KINYARWANDA)
SA (SANSKRIT)
SD (SINDHI)
SG (SANGHO)
SH (SERBO-CROATIAN)
SI (SINGHALESE)
SK (SLOVAK)
SL (SLOVENIAN)
SM (SAMOAN)
SN (SHONA)
SO (SOMALI)
SQ (ALBANIAN)
SR (SERBIAN)
SS (SISWATI)
ST (SESOTHO)
SU (SUNDANESE)
SV (SWEDISH)
SW (SWAHILI)
TA (TAMIL)
TE (TELUGU)
TG (TAJIK)
TH (THAI)
TI (TIGRINYA)
TK (TURKMEN)
TL (TAGALOG)
TN (SETSWANA)
TO (TONGA)
TR (TURKISH)
TS (TSONGA)
TT (TATAR)
TW (TWI)
UK (UKRAINIAN)
UR (URDU)
UZ (UZBEK)
VI (VIETNAMESE)
VO (VOLAPUK)
WO (WOLOF)
XH (XHOSA)
YO (YORUBA)
ZH (CHINESE)
ZU (ZULU)
*/